>From 906d69a083cb639176b886990301971d78c06970 Mon Sep 17 00:00:00 2001
From: Ade Lee <alee@redhat.com>
Date: Tue, 13 Aug 2013 22:51:48 -0400
Subject: [PATCH] Move security domain session classes to correct package

cmscore classes should not depend on classes in cms.
---
 base/common/src/com/netscape/cmscore/apps/CMSEngine.java            | 6 +++---
 .../csadmin => cmscore/session}/LDAPSecurityDomainSessionTable.java | 2 +-
 .../csadmin => cmscore/session}/SecurityDomainSessionTable.java     | 2 +-
 .../{cms/servlet/csadmin => cmscore/session}/SessionTimer.java      | 2 +-
 4 files changed, 6 insertions(+), 6 deletions(-)
 rename base/common/src/com/netscape/{cms/servlet/csadmin => cmscore/session}/LDAPSecurityDomainSessionTable.java (99%)
 rename base/common/src/com/netscape/{cms/servlet/csadmin => cmscore/session}/SecurityDomainSessionTable.java (98%)
 rename base/common/src/com/netscape/{cms/servlet/csadmin => cmscore/session}/SessionTimer.java (98%)

diff --git a/base/common/src/com/netscape/cmscore/apps/CMSEngine.java b/base/common/src/com/netscape/cmscore/apps/CMSEngine.java
index 39ace2ceb0972ca9ba5a2801321c1f95482a7c17..a3172f51ad769d365b89a4e16e0499dffc562fce 100644
--- a/base/common/src/com/netscape/cmscore/apps/CMSEngine.java
+++ b/base/common/src/com/netscape/cmscore/apps/CMSEngine.java
@@ -121,9 +121,6 @@ import com.netscape.certsrv.ra.IRegistrationAuthority;
 import com.netscape.certsrv.request.IRequest;
 import com.netscape.certsrv.request.IRequestQueue;
 import com.netscape.certsrv.request.RequestStatus;
-import com.netscape.cms.servlet.csadmin.LDAPSecurityDomainSessionTable;
-import com.netscape.cms.servlet.csadmin.SecurityDomainSessionTable;
-import com.netscape.cms.servlet.csadmin.SessionTimer;
 import com.netscape.cmscore.authentication.AuthSubsystem;
 import com.netscape.cmscore.authentication.VerifiedCert;
 import com.netscape.cmscore.authentication.VerifiedCerts;
@@ -168,6 +165,9 @@ import com.netscape.cmscore.request.RequestSubsystem;
 import com.netscape.cmscore.security.JssSubsystem;
 import com.netscape.cmscore.security.PWCBsdr;
 import com.netscape.cmscore.security.PWsdrCache;
+import com.netscape.cmscore.session.LDAPSecurityDomainSessionTable;
+import com.netscape.cmscore.session.SecurityDomainSessionTable;
+import com.netscape.cmscore.session.SessionTimer;
 import com.netscape.cmscore.time.SimpleTimeSource;
 import com.netscape.cmscore.usrgrp.UGSubsystem;
 import com.netscape.cmscore.util.Debug;
diff --git a/base/common/src/com/netscape/cms/servlet/csadmin/LDAPSecurityDomainSessionTable.java b/base/common/src/com/netscape/cmscore/session/LDAPSecurityDomainSessionTable.java
similarity index 99%
rename from base/common/src/com/netscape/cms/servlet/csadmin/LDAPSecurityDomainSessionTable.java
rename to base/common/src/com/netscape/cmscore/session/LDAPSecurityDomainSessionTable.java
index ff9ab5eba1e683a6bb0594fc27da83e0b9aca04c..064ae7ecbf253b5d4c74f15342f7c17bbe7efd93 100644
--- a/base/common/src/com/netscape/cms/servlet/csadmin/LDAPSecurityDomainSessionTable.java
+++ b/base/common/src/com/netscape/cmscore/session/LDAPSecurityDomainSessionTable.java
@@ -15,7 +15,7 @@
 // (C) 2010 Red Hat, Inc.
 // All rights reserved.
 // --- END COPYRIGHT BLOCK ---
-package com.netscape.cms.servlet.csadmin;
+package com.netscape.cmscore.session;
 
 import java.util.Date;
 import java.util.Enumeration;
diff --git a/base/common/src/com/netscape/cms/servlet/csadmin/SecurityDomainSessionTable.java b/base/common/src/com/netscape/cmscore/session/SecurityDomainSessionTable.java
similarity index 98%
rename from base/common/src/com/netscape/cms/servlet/csadmin/SecurityDomainSessionTable.java
rename to base/common/src/com/netscape/cmscore/session/SecurityDomainSessionTable.java
index d15ca5ad3febe6456665c245015b490b2e5c76c8..497f42f7a5db47097eff65b4dcfa33bc079fef38 100644
--- a/base/common/src/com/netscape/cms/servlet/csadmin/SecurityDomainSessionTable.java
+++ b/base/common/src/com/netscape/cmscore/session/SecurityDomainSessionTable.java
@@ -15,7 +15,7 @@
 // (C) 2007 Red Hat, Inc.
 // All rights reserved.
 // --- END COPYRIGHT BLOCK ---
-package com.netscape.cms.servlet.csadmin;
+package com.netscape.cmscore.session;
 
 import java.util.Date;
 import java.util.Enumeration;
diff --git a/base/common/src/com/netscape/cms/servlet/csadmin/SessionTimer.java b/base/common/src/com/netscape/cmscore/session/SessionTimer.java
similarity index 98%
rename from base/common/src/com/netscape/cms/servlet/csadmin/SessionTimer.java
rename to base/common/src/com/netscape/cmscore/session/SessionTimer.java
index 2d8a188af882924808cd53431fbd57bf8fc6d2a0..28c06de329997afe83df210653dcadf6bf80e607 100644
--- a/base/common/src/com/netscape/cms/servlet/csadmin/SessionTimer.java
+++ b/base/common/src/com/netscape/cmscore/session/SessionTimer.java
@@ -15,7 +15,7 @@
 // (C) 2007 Red Hat, Inc.
 // All rights reserved.
 // --- END COPYRIGHT BLOCK ---
-package com.netscape.cms.servlet.csadmin;
+package com.netscape.cmscore.session;
 
 import java.util.Date;
 import java.util.Enumeration;
-- 
1.8.1.4